// ***************************************************************************
// *   Copyright (C) 2018 by Paul Lutus                                      *
// *   lutusp@arachnoid.com                                                  *
// *                                                                         *
// *   This program is free software; you can redistribute it and/or modify  *
// *   it under the terms of the GNU General Public License as published by  *
// *   the Free Software Foundation; either version 2 of the License, or     *
// *   (at your option) any later version.                                   *
// *                                                                         *
// *   This program is distributed in the hope that it will be useful,       *
// *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
// *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
// *   GNU General Public License for more details.                          *
// *                                                                         *
// *   You should have received a copy of the GNU General Public License     *
// *   along with this program; if not, write to the                         *
// *   Free Software Foundation, Inc.,                                       *
// *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
// ***************************************************************************

 /*
 * Goto.java
 *
 * Created on February 25, 2002, 3:21 PM
 */

package GotoFunctions;

import Arachnophilia.*;
//import ArachDocument;
//import MyJButton;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author  Administrator
 */
public class Goto extends javax.swing.JDialog {
    
    /** Creates new form Goto */
    public int gotoLine = -1;
    boolean needInit = true;
    public Goto(Arachnophilia m) {
        super(m, true);
        setTitle("Go to");
        initComponents();
        pack();
        Rectangle ss = m.getBounds();
        int w = ss.width/8;
        int h = ss.height/8;
        setLocation(ss.x+w,ss.y+h);
        // gotoField.setText("" + def);
        setVisible(true);
        gotoField.requestFocusInWindow();
    }
    
    private void handleKey(java.awt.event.KeyEvent evt)
    {
        if(evt.getKeyChar() == KeyEvent.VK_ESCAPE) {
            evt.consume();
            quit();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        gotoField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        gotoButton = new MyJButton();
        cancelButton = new MyJButton();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                formFocusGained(evt);
            }
        });
        
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                formKeyTyped(evt);
            }
        });
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        gotoField.setMinimumSize(new java.awt.Dimension(60, 21));
        gotoField.setPreferredSize(new java.awt.Dimension(60, 21));
        gotoField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gotoFieldActionPerformed(evt);
            }
        });
        
        gotoField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                gotoFieldKeyTyped(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        getContentPane().add(gotoField, gridBagConstraints1);
        
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Go to line:");
        jLabel1.setRequestFocusEnabled(false);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        getContentPane().add(jLabel1, gridBagConstraints1);
        
        gotoButton.setText("Go");
        gotoButton.setRequestFocusEnabled(false);
        gotoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gotoButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        getContentPane().add(gotoButton, gridBagConstraints1);
        
        cancelButton.setText("Cancel");
        cancelButton.setRequestFocusEnabled(false);
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        getContentPane().add(cancelButton, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void gotoFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_gotoFieldKeyTyped
        // Add your handling code here:
         handleKey(evt);
    }//GEN-LAST:event_gotoFieldKeyTyped

    private void formKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyTyped
        // Add your handling code here:
        handleKey(evt);
    }//GEN-LAST:event_formKeyTyped

    private void formFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_formFocusGained
        // Add your handling code here:
        gotoField.requestFocusInWindow();
    }//GEN-LAST:event_formFocusGained
    
    private void gotoFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gotoFieldActionPerformed
        // Add your handling code here:
        accept();
    }//GEN-LAST:event_gotoFieldActionPerformed
    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        quit();
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    private void gotoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gotoButtonActionPerformed
        // Add your handling code here:
        accept();
    }//GEN-LAST:event_gotoButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    private void accept() {
        int go = -1;
        try {
            go = Integer.parseInt(gotoField.getText());
        }
        catch (Exception e) {
        }
        if(go >= 0) {
            gotoLine = go;
        }
        quit();
    }
    private void quit() {
        setVisible(false);
        dispose();
    }
    
    /**
     * @param args the command line arguments
     *//*
    public static void main(String args[]) {
        new Goto(new javax.swing.JFrame()).show();
    }*/
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField gotoField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton gotoButton;
    private javax.swing.JButton cancelButton;
    // End of variables declaration//GEN-END:variables
    
}
